package de.mdelab.instanceGraphEditor.ui.parts;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.draw2d.AbstractLayout;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Insets;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.draw2d.graph.DirectedGraph;
import org.eclipse.draw2d.graph.DirectedGraphLayout;

import de.mdelab.instanceGraphEditor.ui.figures.NodeFigure;

class GraphLayoutManager extends AbstractLayout {

	private GraphEditPart diagram;

	GraphLayoutManager(GraphEditPart diagram) {
		this.diagram = diagram;
	}

	protected Dimension calculatePreferredSize(IFigure container, int wHint, int hHint) {
		container.validate();
		List children = container.getChildren();
		Rectangle result = new Rectangle().setLocation(container
				.getClientArea().getLocation());
		for (int i = 0; i < children.size(); i++)
			result.union(((IFigure) children.get(i)).getBounds());
		result.resize(container.getInsets().getWidth(), container.getInsets()
				.getHeight());
		//System.out.println("calculatePreferredSize: " +result.getSize());
		return result.getSize();
	}

	public void layout(IFigure container) {
		
		GraphAnimation.recordInitialState(container);
		if (GraphAnimation.playbackState(container))
			return;

		DirectedGraph graph = new DirectedGraph();
		//graph.setDirection(-1);
		Map partsToNodes = new HashMap();
		diagram.contributeNodesToGraph(graph, partsToNodes);
		diagram.contributeEdgesToGraph(graph, partsToNodes);
		new DirectedGraphLayout().visit(graph);
//		for(int i = 0; i < graph.nodes.size();i++){
//			System.out.println("node: " + ((NodeFigure)((NodesEditPart)graph.nodes.getNode(i).data).getFigure()).getNameLabel().getText());
//		}
//		for(int i = 0; i < graph.edges.size();i++){
//			System.out.println("edge - source: " + ((NodeFigure)((NodesEditPart)graph.edges.getEdge(i).source.data).getFigure()).getNameLabel().getText());
//			System.out.println("edge - target: " + ((NodeFigure)((NodesEditPart)graph.edges.getEdge(i).target.data).getFigure()).getNameLabel().getText());
//		}
		diagram.applyGraphResults(graph, partsToNodes);
	}

}
