package de.mdelab.sdm.interpreter.code.debug.ui.launcher;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EObject;

import de.mdelab.sdm.interpreter.core.SDMInterpreter;
import de.mdelab.sdm.interpreter.core.debug.SDDebugger;
import de.mdelab.sdm.interpreter.core.executionTrace.PerformanceNotificationReceiver;

public abstract class LaunchDebuggerPerfNotificationReceiver<	StoryDiagramElement extends EObject, 
																ActivityType extends EObject,
																ActivityNodeType,
																ActivityEdgeType,
																StoryPatternType,
																StoryPatternObjectType,
																StoryPatternLinkType,
																FeatureType,
																ExpressionType> extends PerformanceNotificationReceiver<	StoryDiagramElement, 
																															ActivityType,
																															ActivityNodeType,
																															ActivityEdgeType,
																															StoryPatternType,
																															StoryPatternObjectType,
																															StoryPatternLinkType,
																															EClassifier,
																															FeatureType,
																															ExpressionType> {
	
	public LaunchDebuggerPerfNotificationReceiver() {
		super();
	}
	
	protected abstract SDDebugger<StoryDiagramElement, ActivityType, ActivityNodeType, StoryPatternType, ExpressionType> createDebugger( 	SDMInterpreter<ActivityType, ActivityNodeType, ActivityEdgeType, StoryPatternType, StoryPatternObjectType, StoryPatternLinkType, EClassifier, FeatureType, ExpressionType> p_interpreter,
																																			int pi_debugServerPort,
																																			int pi_resourceSetSynchronizerPort );

//	@Override
//	protected void traceReExecution( 	final SDMInterpreter<ActivityType, ActivityNodeType, ActivityEdgeType, StoryPatternType, StoryPatternObjectType, StoryPatternLinkType, EClassifier, FeatureType, ExpressionType> p_interpreter,
//										final ActivityNodeType p_activityNode ) 
//	throws SDMException {
//		final Integer serverPort = ConnectionUtil.findNextAvailablePort( 1024 );
//		final Integer lastUsedPort = ConnectionUtil.findNextAvailablePort( serverPort );
//		final SDDebugger<StoryDiagramElement, ActivityType, ActivityNodeType, StoryPatternType, ExpressionType> debugger = createDebugger( p_interpreter, serverPort, lastUsedPort );
//		System.out.println( "Waiting for connection of debug client (debugger port: " + serverPort + ")..." );
//		
//		final Thread debuggerThread = new Thread() {
//			
//			@Override
//			public void run() {
//				try {
//					LaunchDebuggerPerfNotificationReceiver.super.traceReExecution( p_interpreter, p_activityNode );
//				}
//				catch ( final SDMException p_ex ) {
//					throw new RuntimeException( p_ex );
//				}
//			}
//		};
//		
//		debuggerThread.start();
//		
//		try {
//			final ILaunchConfiguration config = getLaunchConfiguration( serverPort );
//			
//			while ( !debugger.isInitialized() ) {
//				Thread.sleep( 500 );
//			}
//						
//			config.launch( ILaunchManager.DEBUG_MODE, new NullProgressMonitor() );
//			
//			while ( !debugger.isTerminated() ) {
//				Thread.sleep( 1000 );
//			}
//		}
//		catch ( final CoreException p_ex ) {
//			throw new SDMException( p_ex );
//		}
//		catch ( final InterruptedException p_ex ) {
//			throw new SDMException( p_ex );
//		}
//
//		p_interpreter.getNotificationEmitter().removeNotificationReceiver( debugger );
//	}
//	
//	private ILaunchConfiguration getLaunchConfiguration( final int pi_serverPort )
//	throws CoreException {
//		final ILaunchManager launchManager =  DebugPlugin.getDefault().getLaunchManager();
//		final ILaunchConfigurationType confType = launchManager.getLaunchConfigurationType( getLaunchConfigTypeId() );
//		final String confName = launchManager.generateLaunchConfigurationName( "SDM_Performances" );
//		final ILaunchConfigurationWorkingCopy config = confType.newInstance( null, confName );
//		config.setAttribute( ISDLaunchUIConstants.ATTR_USE_SERVER_INTERPRETER, true );
//		config.setAttribute( ISDLaunchUIConstants.ATTR_SERVER_ADDRESS, ISDLaunchUIConstants.SERVER_DEFAULT_ADDRESS );
//		config.setAttribute( ISDLaunchUIConstants.ATTR_SERVER_PORT, Integer.toString( pi_serverPort ) );
//		
//		return config;
//	}
	
	protected abstract String getLaunchConfigTypeId();
}
