package de.mdelab.sdm.interpreter.code.debug.ui.launcher.table.instmodels;

import org.eclipse.emf.common.util.URI;
import org.eclipse.jface.viewers.TableViewer;

import de.mdelab.sdm.interpreter.code.debug.ui.launcher.table.ITableViewerListener;

public class InputInstanceModelEditingSupport extends InstanceModelEditingSupport {

	public InputInstanceModelEditingSupport( final TableViewer p_viewer ) {
	    super( p_viewer );
	}

	@Override
	protected URI getInstanceModel( final InstanceModelRow p_row ) {
		return p_row.getInputInstanceModel();
	}

	@Override
	protected void setInstanceModel(	final InstanceModelRow p_row,
										final URI p_resourceUri ) {
		p_row.setInputInstanceModel( p_resourceUri );
	}
	
	@Override
	protected void fireParameterUpdated( final InstanceModelRow p_row ) {
		super.fireParameterUpdated( p_row );
		
	    for ( final ITableViewerListener<InstanceModelRow> listener : editorListeners ) {
	    	if ( listener instanceof IInputModelsTableViewerListener ) {
	    		( (IInputModelsTableViewerListener) listener ).inputModelUpdated( p_row );
	    	}
	    }
	}
}
